<script setup>
import AuthenticatedLayout from "@/Layouts/AuthenticatedLayout.vue";
import { Head } from "@inertiajs/vue3";
import axios from "axios";
import { ref, onBeforeMount } from "vue";

const props = defineProps({
    resource: {
        type: Object,
    },
});
const tags = ref([]);
const new_tag = ref({
  title: "",
  resource_id: props.resource.id
});

const errors = ref({});
const error_message = ref("");

onBeforeMount(() => {
  tags.value = props.resource.tags;
})

function store() {
    errors.value = {};
    axios.post('/tags', new_tag.value).then((response) => {
        console.log(response);
        if (response.status == 200) {
            tags.value.push(response.data);
            new_tag.value.title = "";
        } else {
            console.warn(response.data);
        }
    }).catch((error) => {
        console.log(error);
        if (error.response.status == 422) {
            errors.value = error.response.data.errors;
        } else {
            console.error(error.response.statusText);
        }
    });
}

    function destroy (id) {
      errors.value = {};
      axios.post('/tags/delete', {
        tag_id : id, 
        resource_id : props.resource.id
      }).then((response) => {
        if (response.status == 200) {
          tags.value = tags.value.filter((tag) => {
            return tag.id != id;
          });
        } else {
          console.warn(response.data);
        }
      }).catch((error) => {
        console.error(error.response.statusText);
      });
    }

</script>

<template>
    <div>
      <div class="flex gap-2 mb-2">
        <div v-for="(tag, index) in tags" :key="index">
          <span class="inline-flex items-center rounded-md bg-green-50 px-2 py-1 text-xs font-medium text-green-700 ring-1 ring-inset ring-green-600/20">
            {{ tag.title }} 
            <span class="cursor-pointer ml-2 text-red-700 font-bold px-1 rounded-full bg-red-100 shadow" @click="destroy(tag.id)">x</span> 
          </span>
        </div>
      </div>
      <div>
        <input
            v-model="new_tag.title"
            class="shadow appearance-none rounded w-32 py-1 px-1 text-gray-700 leading-tight border border-gray-400 focus:outline-none focus:shadow-outline"
            type="text"
            placeholder="Add Tags"
        />
        <button class="mx-2 px-3 py-1 bg-green-600 text-white rounded shadow" @click="store">
          Add
        </button>
      </div>
    </div>
</template>